#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

from ...baseset import BaseSetBool, BaseSetText


class SetReplication(BaseSetBool):
    VALIDATE = "Boolean"
    PATH = "replication"


class SetReplicationHost(BaseSetText):
    VALIDATE = "Fqdn"
    PATH = "replication/host"


class SetReplicationShare(BaseSetText):
    VALIDATE = "ShareName"
    VALIDATE_OPTION = {"exempt_duplicate": "true", "exempt_uplow": "true"}
    PATH = "replication/share"


class SetReplicationUserName(BaseSetText):
    VALIDATE = "UserName"
    PATH = "replication/username"
    DEFAULT = "admin"


class SetReplicationPassword(BaseSetText):
    VALIDATE = "LanDiskPass"
    PATH = "replication/passwd"
