# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect, HttpResponse
import os
from datetime import datetime
from project.view import FuncView, RootView
from root.modules.form import BaseForm
import settings

from project.fal.replication import Replication
from project.fal.share import Share

LOGFILE_DIR = '/mnt/sataraid1/replication'


class ReplicationView(FuncView):

    views = []

    class Form(BaseForm):
        pass

    def view(self, req):
        replicated = Replication().read()
        sharelist = list()
        for sharename in sorted(Share().load().keys()):
            share = replicated.get(sharename, None)
            if share is None:
                continue
            sharelist.append(share)
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'sharelist': sharelist,
            },
        }


class DownloadView(RootView):
    NOT_LOGINED_URL = '/'.join([settings.MENU_URL, 'replication'])
    views = []

    def view(self, request, sharename):
        from django.conf import settings
        import zipfile

        logfilepath = os.path.join(LOGFILE_DIR, sharename)
        text = ''
        try:
            with open(logfilepath, 'rb') as f:
                text = f.read()
        except:
            text = ''

        response = HttpResponse(text, mimetype='text/csv')
        response['Content-Disposition'] = 'attachment; filename=%s.log' % sharename
        return {self.KEY_RESPONSE: response}


class ShowView(RootView):
    NOT_LOGINED_URL = '/'.join([settings.MENU_URL, 'replication'])
    views = []

    def view(self, request, sharename):
        logfilepath = os.path.join(LOGFILE_DIR, sharename)
        text = ''
        try:
            with open(logfilepath, 'rb') as f:
                LIMIT = 100
                lines = f.readlines()
                if len(lines) > LIMIT:
                    text = "%s\r\n...\r\n" % _(u"Replication: Please download log.")
                for line in lines[-LIMIT:]:
                    text = text + line
        except:
            text = ''

        response = HttpResponse(text, mimetype='text/plain')
        return {self.KEY_RESPONSE: response}
