#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from ..utils import BaseMeans


class Replication(BaseMeans):
    PATH = "replication/@enable"


class Host(BaseMeans):
    PATH = "replication/host"
    IS_BOOL = False
    DEFAULT = ""


class Share(BaseMeans):
    PATH = "replication/share"
    IS_BOOL = False
    DEFAULT = ""


class Username(BaseMeans):
    PATH = "replication/username"
    IS_BOOL = False
    DEFAULT = "admin"

    # Usernameは"admin"で決め打ちなのでオーバーライド
    def get(self,node):
        return self.DEFAULT
    
    def set(self, node, value):
        self._set_text(node, self.DEFAULT)


class Password(BaseMeans):
    PATH = "replication/passwd"
    IS_BOOL = False
    DEFAULT = ""


means = {
    "replication": Replication(),
    "repli_dest_host": Host(),
    "repli_dest_share": Share(),
    "repli_dest_user": Username(),
    "repli_dest_passwd": Password(),
}
